/* Test A:  30 iterations, 20 threads
In-memory interpreted (implicit conversion) <-- sp_executesql causing index scan instead of seek upon implicit conversion
1:18.3440 seconds
2.0829 seconds average
0.6845 CPU seconds average

Disk (no index)
53.50 seconds
1.3674 seconds average
0.4684 CPU seconds average

Disk (index)
3.72 seconds
0.2197 seconds average
0.0973 CPU seconds average

In-memory interpreted (nvarchar)
0.9216 seconds
0.0059 seconds average
0.0028 CPU seconds average

In-memory compiled (index)
0.8906 seconds; next run was 0.2653 seconds
0.0045 seconds average
0.0025 CPU seconds average

*/

--No implicit conversion problem when the column is nvarchar...
exec sp_executesql N'SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.IncidentInMemory_nvarchar
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;',N'@localcrimereportingcode varchar(5)',@localcrimereportingcode=N'249J'


exec sp_executesql N'SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.IncidentInMemory WITH(INDEX ([IX_IncidentInMemory_LocalCrimeReportingCode]))
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;',N'@localcrimereportingcode nvarchar(4)',@localcrimereportingcode=N'249J'

exec sp_executesql N'SELECT
	IncidentNumber,x
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.IncidentInMemory
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;',N'@localcrimereportingcode varchar(4)',@localcrimereportingcode=N'249J'


DECLARE @LocalCrimeReportingCode varchar(5) = '112';

SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.Incident 
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;

SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.IncidentInMemory_BadIndexing
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;

SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.IncidentInMemory
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;

EXEC dbo.IncidentInMemory_GetIncidentInMemoryByLocalCrimeReportingCode @LocalCrimeReportingCode = @LocalCrimeReportingCode;

GO

/* Test B:  10 iterations, 20 threads
In-memory interpreted (no index)
	5.17 seconds
	0.3125 seconds average
	0.1323 CPU seconds average

Disk (no index)
	12.27 seconds
	0.7989 seconds average
	0.2931 CPU seconds average

In-memory compiled (no index)
	2.59 seconds
	0.0499 seconds average
	0.1599 CPU seconds average
*/

declare @BeatID int = 531;

SELECT
	IncidentID,
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate,
	Beat,
	LocationID
FROM
	PoliceData.IncidentInMemory
WHERE
	Beat = @BeatID;


SELECT
	IncidentID,
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate,
	Beat
FROM
	PoliceData.Incident
WHERE
	Beat = @BeatID;

EXEC dbo.IncidentInMemory_GetIncidentInMemoryByBeat @BeatID = @BeatID;

GO

/* Test C:  concurrent insert & select operations; 20 iterations, 20 threads

Disk
7.34 seconds
0.2693 seconds average
0.0974 CPU seconds average

In-Memory with SPs
0.2497 seconds
0.0031 seconds average
0.0009 CPU seconds average

*/

INSERT INTO PoliceData.Incident
(
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate,
	Beat
)
VALUES
(
	LEFT(CAST(NEWID() AS VARCHAR(36)), 19),
	'111',
	'2099-12-31',
	12345
);

SELECT
	IncidentNumber,
	LocalCrimeReportingCode,
	IncidentDate
FROM PoliceData.Incident
WHERE LocalCrimeReportingCode = @LocalCrimeReportingCode;

DECLARE 
	@IncidentID INT = NEXT VALUE FOR [PoliceData].[IncidentInMemorySequence],
	@IncidentNumber VARCHAR(19) = LEFT(CAST(NEWID() AS VARCHAR(36)), 19),
	@LocalCrimeReportingCode VARCHAR(5) = '111',
	@IncidentDate DATETIME = '2099-12-31',
	@Beat INT = 12345;

EXEC dbo.IncidentInMemory_AddIncidentInMemory
	@IncidentID = @IncidentID,
	@IncidentNumber = @IncidentNumber,
	@LocalCrimeReportingCode = @LocalCrimeReportingCode,
	@IncidentDate = @IncidentDate,
	@Beat = @Beat;

EXEC dbo.IncidentInMemory_GetIncidentInMemoryByLocalCrimeReportingCode @LocalCrimeReportingCode = @LocalCrimeReportingCode;

--Cleanup scripts

delete from policedata.incident where incidentdate = '2099-12-31';
delete from policedata.incidentinmemory where incidentdate = '2099-12-31';

select * from policedata.incidentinmemory where incidentdate = '2099-12-31'